Centos6.5安装erlang过程及问题总结[转载]

今天在Centos6.5下安装erlang,过程真是一波三折,总结一下:
下载erlang源代码包,选择版本,这里以erlang R16B03为例作说明:
1 wget http://www.erlang.org/download/otp_src_R16B03.tar.gz
2 tar -zxf otp_src_R16B03.tar.gz
3 cd otp_src_R16B03
4 mkdir -p /home/erl
5 ./configure --prefix=/home/erl
6 make && make install
7 ln -s /home/erl/bin/erl /usr/bin/erl
依赖组件
报错信息
解决
C compiler
configure: error: no acceptable C compiler found in $PATH
See ‘config.log’ for more details.
yum install gcc
curses library
configure: error: No curses library functions found
configure: error: /bin/sh ‘/home/otp_src_R16B03/erts/configure’ failed for erts
yum install ncurses-devel
安装erlang的时候可能会出现以下警告信息,但不影响erlang使用,如果要用到以下apps,就必须装好依赖:
01 *********************************************************************
02 ********************** APPLICATIONS DISABLED **********************
03 *********************************************************************
04 crypto : No usable OpenSSL found
05 jinterface : No Java compiler found
06 odbc : ODBC library - link check failed
07 orber : No C++ compiler found
08 ssh : No usable OpenSSL found
09 ssl : No usable OpenSSL found
10 *********************************************************************
没装依赖的话会遇到什么问题,比如像用crypto,将会提示没有这个函数
1 Eshell V5.10.4 (abort with ^G)
2 1> crypto:start().
3 ** exception error: undefined function crypto:start/0

这里有个问题,如果是装openssl,不是openssl-devel的话,crypto还是无法使用。

依赖组件
没装无法使用的apps
解决
OpenSSL
crypto、ssh、ssl
yum install openssl-devel
Java compiler
jinterface
yum install java-devel
ODBC library
odbc
yum install unixODBC-devel
C++ compiler
orber
yum install gcc-c++

事实上,openssl-devel在erlang中还是不能满足使用的,还需要做一些改动。

1 Eshell V5.10.4 (abort with ^G)
2 1> crypto:start().
3 =ERROR REPORT==== 24-Sep-2014::15:10:46 ===
4 Unable to load crypto library. Failed with error:
5 "load_failed, Failed to load NIF library: '/home/erl/lib/erlang/lib/crypto-3.2/priv/lib/crypto.so: undefined symbol: EC_GROUP_new_curve_GF2m'"
6 OpenSSL might not be installed on this system.

erlang R16B以上版本运行crypto:start()时,提示crypto.so: undefined symbol: EC_GROUP_new_curve_GF2m,是因为新版的libssl库去除了对一些过时算法的支持,如果程序用不到,可以注释掉otp_src_R16B0x/lib/crypto/c_src/crypto.c第81行# define HAVE_EC即可。

1 Eshell V5.10.4 (abort with ^G)
2 1> crypto:start().
3 ok
4 2> crypto:md5("ggg").
5 <<186,36,140,152,90,206,148,134,56,128,146,29,137,0,197,63>>
6 3> crypto:info_lib().
7 [{<<"OpenSSL">>,268439647,
8   <<"OpenSSL 1.0.1e-fips 11 Feb 2013">>}]

网上还有另一种做法:修改openssl对EC的支持

1 wget http://www.openssl.org/source/openssl-1.0.1i.tar.gz
2 tar -zxf openssl-1.0.1i.tar.gz
3 cd openssl-1.0.1i
4 ./config --prefix=/home/ssl 
5 sed -i "s|CFLAG= |CFLAG= -fPIC |" Makefile
6 make && make install
编译erlang的时候要做改动:
1 ./configure --with-ssl=/home/ssl/ --prefix=/home/erl

参考:http://blog.csdn.net/mycwq/article/details/39524847

发表评论

电子邮件地址不会被公开。 必填项已用*标注